finley::ShapeFunction Struct Reference

this struct holds the evaluation of a shape function on a quadrature scheme More...

`#include <ShapeFunctions.h>`

## Public Member Functions

| ShapeFunction (ShapeFunctionTypeId id, int numQuadDim, int numQuadNodes, const std::vector< double > &QuadNodes, const std::vector< double > &QuadWeights)
ShapeFunctionTypeId | getTypeId (const char *)

## Static Public Member Functions

static const ShapeFunctionInfo * | getInfo (ShapeFunctionTypeId id)

## Public Attributes

const ShapeFunctionInfo * | Type
| shape function information More...
int | numQuadNodes
| number of quadrature points More...
std::vector< double > | QuadNodes
| coordinates of quadrature nodes More...
std::vector< double > | QuadWeights
| weights of the quadrature scheme More...
std::vector< double > | S
| shape functions at quadrature nodes More...
std::vector< double > | dSdv
| derivative of the shape functions at quadrature nodes More...

## Detailed Description

this struct holds the evaluation of a shape function on a quadrature scheme

## Constructor & Destructor Documentation

## ShapeFunction()

finley::ShapeFunction::ShapeFunction | ( | ShapeFunctionTypeId | id,
|  | int | numQDim,
|  | int | numQNodes,
|  | const std::vector< double > & | qNodes,
|  | const std::vector< double > & | qWeights
| ) |  |

Creates an evaluation of the ShapeFunction on the given quadrature scheme. If QuadNodes==Null or QuadWeights==Null the shape functions method is used to generate a quadrature scheme with numQuadNodes nodes. Otherwise it is assumed that a quadrature scheme is given on this array and a copy is created within the structure.

References dSdv, getInfo(), finley::ShapeFunctionInfo::getValues, INDEX2, finley::ShapeFunctionInfo::numDim, numQuadNodes, finley::ShapeFunctionInfo::numShapes, QuadNodes, QuadWeights, S, finley::ShapeFunction_InfoList, and Type.

## Member Function Documentation

## getInfo()

const ShapeFunctionInfo * finley::ShapeFunction::getInfo | ( | ShapeFunctionTypeId | id | ) |

static

References finley::NoShape, and finley::ShapeFunction_InfoList.

Referenced by finley::ReferenceElement::ReferenceElement(), finley::ReferenceElementSet::ReferenceElementSet(), and ShapeFunction().

## getTypeId()

ShapeFunctionTypeId finley::ShapeFunction::getTypeId | ( | const char * | element_type | ) |

References finley::NoShape, finley::ShapeFunction_InfoList, and finley::ShapeFunctionInfo::TypeId.

## Member Data Documentation

## dSdv

std::vector<double> finley::ShapeFunction::dSdv

derivative of the shape functions at quadrature nodes

Referenced by ShapeFunction().

## numQuadNodes

int finley::ShapeFunction::numQuadNodes

number of quadrature points

Referenced by ShapeFunction().

## QuadNodes

std::vector<double> finley::ShapeFunction::QuadNodes

coordinates of quadrature nodes

Referenced by ShapeFunction().

## QuadWeights

std::vector<double> finley::ShapeFunction::QuadWeights

weights of the quadrature scheme

Referenced by ShapeFunction().

## S

std::vector<double> finley::ShapeFunction::S

shape functions at quadrature nodes

Referenced by ShapeFunction().

## Type

const ShapeFunctionInfo* finley::ShapeFunction::Type

shape function information

Referenced by ShapeFunction().

The documentation for this struct was generated from the following files:

- ShapeFunctions.h
- ShapeFunctions.cpp